--Actel test bench for edac module I using shortened Hamming code(36,29)
--Generated by Actel Shorten Hamming Code RTL Generator


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;
use work.edacconfig.all;

use std.textio.all;

package edactbpack is

constant halfperiod : time := 50 ns;    -- half of the read clock period
type ramarray is array (integer range <> ) of std_logic_vector(CL-1 downto 0);
type intarray is array (integer range <> ) of integer;

constant MAXRAMDEPTH : integer := 4096; -- MAXRAMDEPTH=2**AL, only for testbench

type operation is (r_data,w_data,add_err);
type testlist is (init,usr_read_all,add_one_error,usr_read_write, usr_random_rw_err,usr_random_2_err);

type alltest is (
init,
read_init,
scrub_init,
add_1_err_init,
read_1_err_init,
scrub_1_err_init,
read_1_err_scrubed,
add_1_err_2,
usr_rw,
usr_random_rw_err,
usr_random_2_err,
finished
);


type alldrvsig is
record
        we              : std_logic; 
        re              : std_logic; 
        waddr           : std_logic_vector(AL-1 downto 0); 
        raddr           : std_logic_vector(AL-1 downto 0);
        wdata           : std_logic_vector(ML-1 downto 0); 
        rstn            : std_logic;  
        tmout           : std_logic_vector(TL-1 downto 0);   -- TL=42 : 2^42 * 2 * 10^-8 /24/3600 = 1 day, period = tout*period of
        rds             : std_logic_vector(3 downto 0);      -- RAM depth selection, total RAM words=(rds+1)*256 
        stop_scrub      : std_logic;  
        bypass          : std_logic;                       -- bypass edac and edac, enable wp, rp, active high
        wp              : std_logic_vector(SL-1 downto 0); -- for testing, access the parity bits, tie ground during normal op
end record;

type allmonsig is
record
        rdata           : std_logic_vector(ML-1 downto 0); 
        rp              : std_logic_vector(SL-1 downto 0);-- for testing, access the parity bits
	scrub_corrected	: std_logic;
        caddr           : std_logic_vector(AL-1 downto 0);-- for testing 
	error		: std_logic;
        scrub_done      : std_logic;
        tmoutflg        : std_logic;

	correctable 	: std_logic;
	slowdown 	: std_logic;
end record;

type allstatsig is
record
	err	 	  : integer;
	err_others 	  : integer;
	err_0	 	  : integer;
	err_1	 	  : integer;
	err_2	 	  : integer;
	err_1_added 	  : integer;
	err_2_added 	  : integer;
	err_1_corrected   : integer;
	err_2_detected    : integer;
	ma 		  : integer;
	clear 		  : std_logic;
	rds		  : std_logic_vector(3 downto 0);
	clearaddr	  : std_logic_vector(AL-1 downto 0);
	data_writed	  : ramarray(0 to MAXRAMDEPTH-1);
	data_real	  : ramarray(0 to MAXRAMDEPTH-1);
	ebits	  	  : intarray(0 to MAXRAMDEPTH-1);
	e2mark	  	  : intarray(0 to MAXRAMDEPTH-1);
	op		  : operation;
	test		  : testlist;
	testname	  : alltest;
end record;

function check_status (
signal	statsig	: in  allstatsig
) return boolean;


procedure alter_pattern (
start 	: in integer;
sd 	: out std_logic_vector(ML-1 downto 0)
);

procedure printf( str : STRING);

procedure wait_clock (
signal	clk 	: in std_logic;
count	: in  integer
);
procedure init_ram (
signal	clk 	: in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig
);
procedure usr_read_all (
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig;
signal	cflag	: in intarray(0 to MAXRAMDEPTH-1)
); 
procedure add_one_error (
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig
);
procedure write_data (
signal	clk 	: in std_logic;
wd 		: in std_logic_vector(ML-1 downto 0);
wa 		: in std_logic_vector(AL-1 downto 0);
signal	drvsig 	: out alldrvsig;
signal	monsig 	: in allmonsig;
signal	statsig	: inout  allstatsig
) ;

procedure read_data (
signal	clk 	: in std_logic;
ra 		: in std_logic_vector(AL-1 downto 0);
signal	drvsig 	: out alldrvsig;
signal	monsig 	: in allmonsig;
signal	statsig	: inout  allstatsig;
signal	cflag	: in intarray(0 to MAXRAMDEPTH -1)
);

procedure add_error (
signal	clk 	: in std_logic;
wa 		: in std_logic_vector(AL-1 downto 0);
errval 		: in std_logic_vector(CL-1 downto 0);
signal	drvsig 	: out alldrvsig;
signal	monsig 	: in allmonsig;
signal	statsig	: inout  allstatsig
);
procedure usr_read_write (
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig;
signal cflag : intarray(0 to MAXRAMDEPTH-1)
); 

procedure usr_random_rw_err (
  count     : in integer;
  rseed     : in integer;
  maxd    : in integer;
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig;
signal cflag : intarray(0 to MAXRAMDEPTH-1)
);
procedure usr_random_2_err (
  count     : in integer;
  rseed     : in integer;
  maxd    : in integer;
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig;
signal cflag : intarray(0 to MAXRAMDEPTH-1)
);
procedure RANDOM (variable Seed: inout integer; variable X: out real);
end edactbpack;

package body edactbpack is

procedure RANDOM (variable Seed: inout integer; variable X: out real) is
----------------------------------------------------------------------
-- Random Number generator from:
-- The Art of Computer Systems Performance Analysis, R.Jain 1991 (p443)
--   x(n) := 7^5x(n-1) mod (2^31 - 1)
--   This has period 2^31 - 2, and it works with odd or even seeds
--   This code does not overflow for 32 bit integers.
----------------------------------------------------------------------
constant a : integer := 16807;     -- multiplier 7**5
constant m : integer := 2147483647;-- modulus    2**31 - 1
constant q : integer := 127773;    -- m DIV a
constant r : integer := 2836;      -- m MOD a
constant m_real : real := real(M);

variable seed_div_q  : integer;
variable seed_mod_q  : integer;
variable new_seed : integer;

begin
seed_div_q := seed / q;         -- truncating integer division
seed_mod_q := seed MOD q;       -- modulus
new_seed := a * seed_mod_q - r * seed_div_q;
if (new_seed  >  0) then
seed := new_seed;
else
seed := new_seed + m;
end if;
X := real(seed) / m_real;
end RANDOM;



procedure  alter_pattern(
start : integer; 
sd : out std_logic_vector(ML-1 downto 0) 
) is
variable flag : integer;
begin
	flag := start; 
	for i in 0 to ML-1 loop
		if flag = 0 then
			sd(i) := '0' ;
			flag := 1;
		else
			sd(i) := '1' ;
			flag := 0;
		end if;
	end loop;

end alter_pattern;

procedure printf( str  : STRING) is
file FSTR : TEXT is out"STD_OUTPUT";
variable ll   : LINE;
begin
write( ll , str );
writeline(FSTR, ll);
end printf;

procedure write_data (
signal	clk 	: in std_logic;
wd 		: in std_logic_vector(ML-1 downto 0);
wa 		: in std_logic_vector(AL-1 downto 0);
signal	drvsig 	: out alldrvsig;
signal	monsig 	: in allmonsig;
signal	statsig	: inout  allstatsig
) is
begin
	wait until clk'event and clk = CLKP;
		statsig.op <= w_data;
		drvsig.wdata <=  wd;
		drvsig.waddr <=  wa;
		drvsig.we <=  '1';
		statsig.ebits(conv_integer(wa)) <= 0;
		statsig.e2mark(conv_integer(wa)) <= 0;
		statsig.clear <= '1';
		statsig.clearaddr <= wa;
		if statsig.ebits(conv_integer(wa)) = 1 then
			statsig.err_1_corrected <= statsig.err_1_corrected + 1;
		end if;
		if statsig.ebits(conv_integer(wa)) = 2 and statsig.e2mark(conv_integer(wa)) = 0 then
			statsig.err_2_detected <= statsig.err_2_detected + 1;
		end if;
	wait until clk'event and clk = CLKP;
		statsig.clear <= '1';
		statsig.clearaddr <= wa;
		if statsig.ebits(conv_integer(wa)) = 1 then
			statsig.err_1_corrected <= statsig.err_1_corrected + 1;
		end if;
		if statsig.ebits(conv_integer(wa)) = 2 and statsig.e2mark(conv_integer(wa)) = 0 then
			statsig.err_2_detected <= statsig.err_2_detected + 1;
		end if;
		drvsig.we <=  '0';
		drvsig.re <=  '1';
		drvsig.raddr <=  wa;
		statsig.clear <= '0';
	wait until clk'event and clk = CLKP;
		statsig.clear <= '0';
		drvsig.re <=  '0';
	wait until clk'event and clk = CLKP;
		statsig.data_writed(conv_integer(wa)) <= wd & monsig.rp;
		statsig.data_real(conv_integer(wa)) <= monsig.rdata & monsig.rp;
		if wd /= monsig.rdata  or monsig.error = '1' then
			statsig.err_0  <= statsig.err_0 + 1;
		end if;
end write_data;

procedure wait_clock (
signal	clk 	: in std_logic;
count	: in  integer
) is
begin
	for i in 0 to count loop
		wait until clk'event and clk = CLKP;
	end loop;
end wait_clock;

procedure read_data (
signal	clk 	: in std_logic;
ra 		: in std_logic_vector(AL-1 downto 0);
signal	drvsig 	: out alldrvsig;
signal	monsig 	: in allmonsig;
signal	statsig	: inout  allstatsig;
signal	cflag	: in intarray(0 to MAXRAMDEPTH -1)
) is
begin
	wait until clk'event and clk = CLKP;
		statsig.op <= r_data;
		drvsig.re <=  '1';
		drvsig.raddr <=  ra;
	wait until clk'event and clk = CLKP;
		drvsig.re <=  '0';
	wait until clk'event and clk = CLKP;
		statsig.data_real(conv_integer(ra)) <= monsig.rdata & monsig.rp;
		case  statsig.ebits(conv_integer(ra)) is
		when 0 =>
			if statsig.data_writed(conv_integer(ra)) /= (monsig.rdata & monsig.rp)  or monsig.error = '1' then
				statsig.err_0  <= statsig.err_0 + 1;
			end if;
		when 1 =>
			if cflag(conv_integer(ra)) = 1 then
				statsig.ebits(conv_integer(ra)) <= 0;
				if monsig.caddr /= ra and ( statsig.data_writed(conv_integer(ra)) /= (monsig.rdata & monsig.rp)  or monsig.error = '1' ) then
					statsig.err_0  <= statsig.err_0 + 1;
				end if;
				statsig.clear <= '1';
				statsig.clearaddr <= ra;
				statsig.err_1_corrected <= statsig.err_1_corrected + 1;
			else
				if statsig.data_writed(conv_integer(ra)) /= (monsig.rdata & monsig.rp)   or monsig.error /= '1' or monsig.correctable /= '1'  then
					statsig.err_1  <= statsig.err_1 + 1;
				end if;
			end if;
		when 2 =>
				if monsig.error /= '1' or monsig.correctable /= '0'  then
					statsig.err_2  <= statsig.err_2 + 1;
				else
					if statsig.e2mark(conv_integer(ra)) = 0   then
						statsig.err_2_detected <= statsig.err_2_detected + 1;
						statsig.e2mark(conv_integer(ra)) <=  1;
					end if;
				end if;

		when others => 
				printf("Errors more than 2 are found in one code word");
				statsig.err_others  <= statsig.err_others + 1;
		end case;
	wait until clk'event and clk = CLKP;
				statsig.clear <= '0';
end read_data;

procedure add_error (
signal	clk 	: in std_logic;
wa 		: in std_logic_vector(AL-1 downto 0);
errval 		: in std_logic_vector(CL-1 downto 0);
signal	drvsig 	: out alldrvsig;
signal	monsig 	: in allmonsig;
signal	statsig	: inout  allstatsig
) is
variable errsum : integer;
begin

	if statsig.ebits(conv_integer(wa)) = 0 then 

	wait until clk'event and clk = CLKP;
		statsig.op <= add_err;
		drvsig.bypass <= '1';
		drvsig.re <=  '1';
		drvsig.raddr <=  wa;
	wait until clk'event and clk = CLKP;
		drvsig.re <=  '0';
	wait until clk'event and clk = CLKP;
		drvsig.we <=  '1';
		drvsig.waddr <=  wa;
		drvsig.wdata(ML-1 downto 0) <=  monsig.rdata(ML-1 downto 0) xor errval(CL-1 downto SL);
		drvsig.wp(SL-1 downto 0)    <=  monsig.rp(SL-1 downto 0) xor errval(SL-1 downto 0);
		    errsum := 0;
		   for i in 0 to CL-1 loop
			if  errval(i) = '1' then
				errsum := errsum + 1;
			end if;
		   end loop;
		statsig.ebits(conv_integer(wa)) <= errsum;
		statsig.data_real(conv_integer(wa)) <= (monsig.rdata(ML-1 downto 0) & monsig.rp(SL-1 downto 0) ) xor errval(CL-1 downto 0);

		if errsum = 1 then
			statsig.err_1_added <= statsig.err_1_added +1;
		end if;
		if errsum = 2 then
			statsig.err_2_added <= statsig.err_2_added +1;
		end if;
	wait until clk'event and clk = CLKP;
		statsig.clear <= '1';
		statsig.clearaddr <= wa;
		drvsig.we <=  '0';
		drvsig.bypass <= '0';
	wait until clk'event and clk = CLKP;
		statsig.clear <= '0';
	end if;
end add_error;

procedure init_ram (
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig
) is
variable rdsv : std_logic_vector(3 downto 0);
variable mav : integer;
begin
	statsig.test <= init;
	printf("    init_ram with zeros");
	statsig.err_others <= 0;	
	statsig.err_0 <= 0;	
	statsig.err_1 <= 0;	
	statsig.err_2 <= 0;	
	statsig.err_1_added <= 0;	
	statsig.err_2_added <= 0;	
	statsig.err_1_corrected <= 0;
	statsig.err_2_detected <= 0;
	statsig.clear <= '0';
	statsig.clearaddr <= (others=> '0');
	statsig.e2mark <= (others=> 0);
	statsig.ebits <= (others=> 0);
	statsig.data_writed <= (others=> (others=>'0'));
	statsig.data_real <= (others=> (others=>'0'));
	drvsig.wdata <= (others=>'0');
	drvsig.waddr <= (others=>'0');
	drvsig.raddr <= (others=>'0');
	drvsig.we <= '0';
	drvsig.re <= '0';
	drvsig.rstn <= '0';
        drvsig.wp <= (others => '0');
	drvsig.bypass <= '0';

	wait for halfperiod*5;
	drvsig.rstn <= '1';

        drvsig.rds <=  statsig.rds;
        case statsig.rds is
        when "0001" => mav := 256*2;  
        when "0010" => mav := 256*3;  
        when "0011" => mav := 256*4;  
        when "0100" => mav := 256*5;
        when "0101" => mav := 256*6;
        when "0110" => mav := 256*7;
        when "0111" => mav := 256*8;
        when "1000" => mav := 256*9;
        when "1001" => mav := 256*10;
        when "1010" => mav := 256*11;
        when "1011" => mav := 256*12; 
        when "1100" => mav := 256*13; 
        when "1101" => mav := 256*14;  
        when "1110" => mav := 256*15;
        when "1111" => mav := 256*16;
        when others => mav := 256;
        end case;

	statsig.ma <= mav;

	for i in 0 to mav-1  loop
		write_data(clk,conv_std_logic_vector(i,ML), conv_std_logic_vector(i,AL),drvsig,monsig,statsig);
	end loop;

	if      statsig.err_others        = 0 and 	  
		statsig.err_0	 	  = 0 and 
		statsig.err_1	 	  = 0 and 
		statsig.err_2	 	  = 0 and 
		statsig.err_1_added 	  = 0 and 
		statsig.err_2_added 	  = 0 and 
		statsig.err_1_corrected   = 0 and 
		statsig.err_2_detected    = 0  then

			printf("      initialization are passed");
	else
			statsig.err <= statsig.err + 1;
			printf("      initialization are failed");
	end if;

end init_ram;

procedure usr_read_all (
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig;
signal	cflag	: in intarray(0 to MAXRAMDEPTH-1)
) is
begin
	statsig.test <= usr_read_all;
	printf("   read all ram locations");

	for i in 0 to statsig.ma-1  loop
		read_data(clk,conv_std_logic_vector(i,AL),drvsig,monsig,statsig,cflag);
	end loop;

	if      statsig.err_others        = 0 and 	  
		statsig.err_0	 	  = 0 and 
		statsig.err_1	 	  = 0 and 
		statsig.err_2	 	  = 0 then
			printf("      user read all are passed");
	else
			statsig.err <= statsig.err + 1;
			printf("      user read all are failed");
	end if;

end usr_read_all;

procedure add_one_error (
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig
) is
variable errval : std_logic_vector(CL-1 downto 0);
variable j : integer;
begin
	statsig.test <= add_one_error;
	printf("   add one error all ram locations");

	j := 0;
	for i in 0 to statsig.ma-1  loop
		errval := (others => '0');	
		errval(j) := '1';	
		add_error(clk,conv_std_logic_vector(i,AL), errval,drvsig,monsig,statsig);
		if j = CL -1  then
			j := 0 ;
		end if;
	end loop;

	if      statsig.err_others        = 0 and 	  
		statsig.err_0	 	  = 0 and 
		statsig.err_1	 	  = 0 and 
		statsig.err_2	 	  = 0 then
			printf("     one error is successfully added to each location"); 
	else
			statsig.err <= statsig.err + 1;
			printf("     one error is not successfully added to each location"); 
	end if;

end add_one_error;

procedure usr_read_write (
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig;
signal cflag : intarray(0 to MAXRAMDEPTH-1)
) is
begin
	statsig.test <= usr_read_write;
	printf("   read/write alternative");

	for i in 0 to statsig.ma-1  loop
		read_data(clk,conv_std_logic_vector(statsig.ma-1-i,AL),drvsig,monsig,statsig,cflag);
		write_data(clk,conv_std_logic_vector(i,ML), conv_std_logic_vector(i,AL),drvsig,monsig,statsig);
	end loop;

	if      statsig.err_others        = 0 and 	  
		statsig.err_0	 	  = 0 and 
		statsig.err_1	 	  = 0 and 
		statsig.err_2	 	  = 0 then
			printf("     alternate read/write presents no errors"); 
	else
			statsig.err <= statsig.err + 1;
			printf("     alternate read/write find some errors"); 
	end if;

end usr_read_write;


function check_status (
signal	statsig	: in  allstatsig
) return boolean is
begin

	if statsig.err_others = 0 and
	 statsig.err_0 = 0  and
	 statsig.err_1 = 0  and
	 statsig.err_2 = 0  and 
	 statsig.err_1_added = statsig.err_1_corrected  and
	 statsig.err_2_added = statsig.err_2_detected  then
		  return TRUE;
	else
		  return FALSE;
	end if;
end check_status;

procedure usr_random_rw_err (
  count     : in integer;
  rseed     : in integer;
  maxd    : in integer;
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig;
signal cflag : intarray(0 to MAXRAMDEPTH-1)
) is
variable randi : integer;
variable randx : real;
variable md : std_logic_vector(ML-1 downto 0);
variable cd : std_logic_vector(CL-1 downto 0);
variable ad : std_logic_vector(AL-1 downto 0);
variable errval : std_logic_vector(CL-1 downto 0);
variable tmpi : integer;
variable tv : integer;
variable rcase : integer;
begin
	statsig.test <= usr_read_write;
	printf("   read/write alternative");

	randi := rseed;	

	tv := maxd;

	for i in 1 to count loop
		random(randi, randx);
		wait_clock(clk,randi mod tv);

		random(randi, randx);
		rcase := randi mod 3;
		case rcase is
		when 0 => 
			random(randi, randx);
			ad := conv_std_logic_vector(randi mod statsig.ma, AL);	
			read_data(clk,ad,drvsig,monsig,statsig,cflag);
		when 1 => 
			random(randi, randx);
			ad := conv_std_logic_vector(randi mod statsig.ma, AL);	
			random(randi, randx);
			md := conv_std_logic_vector(randi, ML);	
			write_data(clk,md,ad,drvsig,monsig,statsig);
		when others => 
			random(randi, randx);
			ad := conv_std_logic_vector(randi mod statsig.ma, AL);	
			random(randi, randx);
			errval := (others => '0');	
			tmpi := randi mod CL;
			errval(tmpi) := '1';	
			add_error(clk,ad,errval,drvsig,monsig,statsig);
		end case;
	end loop;
	
	drvsig.stop_scrub <= '1';
	wait until clk'event and clk = '1';
	wait until clk'event and clk = '1';
	drvsig.stop_scrub <= '0';

	wait until monsig.scrub_done'event and monsig.scrub_done = '1';

	usr_read_all(clk,drvsig,monsig,statsig,cflag);

	if      statsig.err_others        = 0 and 	  
		statsig.err_0	 	  = 0 and 
		statsig.err_1	 	  = 0 and 
		statsig.err_2	 	  = 0 then
			printf("     random read/write presents no errors"); 
	else
			statsig.err <= statsig.err + 1;
			printf("     random read/write find some errors"); 
	end if;

end usr_random_rw_err;

procedure usr_random_2_err (
  count     : in integer;
  rseed     : in integer;
  maxd    : in integer;
signal  clk     : in std_logic;
signal	drvsig 	: out alldrvsig;
signal	monsig	: in  allmonsig;
signal	statsig	: inout  allstatsig;
signal cflag : intarray(0 to MAXRAMDEPTH-1)
) is
variable randi : integer;
variable randx : real;
variable md : std_logic_vector(ML-1 downto 0);
variable cd : std_logic_vector(CL-1 downto 0);
variable ad : std_logic_vector(AL-1 downto 0);
variable errval : std_logic_vector(CL-1 downto 0);
variable tmpi : integer;
variable tv : integer;
variable rcase : integer;
begin
	statsig.test <= usr_random_2_err;
	printf("   read/write alternative");

	randi := rseed;	

	tv := maxd;

	for i in 1 to count loop
		random(randi, randx);
		wait_clock(clk,randi mod tv);

		random(randi, randx);
		rcase := randi mod 3;
		case rcase is
		when 0 => 
			random(randi, randx);
			ad := conv_std_logic_vector(randi mod statsig.ma, AL);	
			read_data(clk,ad,drvsig,monsig,statsig,cflag);
		when 1 => 
			random(randi, randx);
			ad := conv_std_logic_vector(randi mod statsig.ma, AL);	
			random(randi, randx);
			md := conv_std_logic_vector(randi, ML);	
			write_data(clk,md,ad,drvsig,monsig,statsig);
		when others => 
			random(randi, randx);
			ad := conv_std_logic_vector(randi mod statsig.ma, AL);	
			random(randi, randx);
			errval := (others => '0');	
			tmpi := randi mod CL;
			errval(tmpi) := '1';	

			while tmpi = (randi mod CL) loop
				random(randi, randx);
			end loop;
			errval(randi mod CL) := '1';	
			add_error(clk,ad,errval,drvsig,monsig,statsig);
		end case;
	end loop;
	
	drvsig.stop_scrub <= '1';
	wait until clk'event and clk = '1';
	wait until clk'event and clk = '1';
	drvsig.stop_scrub <= '0';

	wait until monsig.scrub_done'event and monsig.scrub_done = '1';

	usr_read_all(clk,drvsig,monsig,statsig,cflag);

	if check_status(statsig) then
			printf("     random 2 error test presents no errors"); 
	else
			statsig.err <= statsig.err;
			printf("     random 2 error test  find some errors"); 
	end if;

end usr_random_2_err;


end edactbpack;




library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;
use work.edacconfig.all;
use work.edactbpack.all;

entity testbench is
end testbench;
architecture edactb_behav of testbench is


component edacrami -- should match your top-level entity name
    port( 
-- regular memory ports
        clk             : in std_logic; 
        we              : in std_logic; 
        re              : in std_logic; 
        waddr           : in std_logic_vector(AL-1 downto 0); 
        raddr           : in std_logic_vector(AL-1 downto 0);
        wdata           : in std_logic_vector(ML-1 downto 0); 
        rdata           : out std_logic_vector(ML-1 downto 0);   
-- special ports for edac
        rstn            : in std_logic;  
  --    tmout           : in std_logic_vector(TL-1 downto 0);   -- TL=42 : 2^42 * 2 * 10^-8 /24/3600 = 1 day, period = tout*period of
  --    rds             : in std_logic_vector(3 downto 0);      -- RAM depth selection, total RAM words=(rds+1)*256 
        stop_scrub      : in std_logic;                       --  stop scrub when high.
        bypass          : in std_logic;                       -- bypass edac and edac, enable wp, rp, active high
        wp              : in std_logic_vector(SL-1 downto 0); -- for testing, access the parity bits, tie ground during normal op
        rp              : out std_logic_vector(SL-1 downto 0);-- for testing, access the parity bits
-- special optional ports for edac
        slowdown        : out std_logic;
        scrub_corrected : out std_logic; -- low to high transaction indicates one error was corrected in ram location of caddr
        caddr           : out std_logic_vector(AL-1 downto 0);-- access to the address of cell being corrected
        error           : out std_logic;
        scrub_done      : out std_logic;
        tmoutflg        : out std_logic;
        correctable     : out std_logic
        );
end component;



signal statsig : allstatsig ;
signal drvsig : alldrvsig ;
signal monsig : allmonsig;
signal stopclk : std_logic := '0';
signal clk : std_logic := '0';
signal cflag : intarray(0 to MAXRAMDEPTH-1) := (others=>0);
signal errori, correctablei : std_logic;

begin

<top>_0 : edacrami -- should match your top-level entity name
    port map( 
-- regular memory ports
        clk             => clk,
        we              => drvsig.we,
        re              => drvsig.re,
        waddr           => drvsig.waddr,
        raddr           => drvsig.raddr,
        wdata           => drvsig.wdata,
        rdata           => monsig.rdata,
-- special ports for edac
        rstn            => drvsig.rstn,
    --  tmout           => drvsig.tmout,
    --  rds             => drvsig.rds,
        stop_scrub      => drvsig.stop_scrub,
        bypass          => drvsig.bypass,
        wp              => drvsig.wp,
        rp              => monsig.rp,
-- special optional ports for edac
        slowdown        => monsig.slowdown,
        scrub_corrected => monsig.scrub_corrected,
        caddr           => monsig.caddr,
        error           => errori,
        scrub_done      => monsig.scrub_done,
        tmoutflg      => monsig.tmoutflg,
        correctable     => correctablei
        );

process(errori, correctablei)
begin
        if errori = '0'  and correctablei = '1' then
                monsig.error <= '1';
                monsig.correctable  <= '1';
        elsif errori = '1'  and correctablei = '0' then
                monsig.error        <= '1';
                monsig.correctable  <= '0';
        else
                monsig.error        <= '0';
                monsig.correctable  <= '0';
        end if;
end process;




process
begin
	wait for halfperiod; 
	clk <= '0';
	wait for halfperiod; 
	clk <= '1';

	if stopclk = '1'  then
		wait;
	end if;
end process;

process
variable tmpi : integer;
variable x : real;
begin
	printf("*****************************************************");
	printf("----------------------------------------------");
	printf("Actel EDAC RAM testbench");
	printf("----------------------------------------------");
	printf("");

	statsig.err       <= 0; 
	printf("*****************************************************");
	printf("----------------------------------------------");
	printf("Test: init");  
	printf("Initialization");  
	printf("RAM depth=256"); 
	printf("----------------------------------------------");
	statsig.testname  <= init; 
	statsig.rds       <= "0000"; 
        drvsig.stop_scrub <= '1';
        drvsig.tmout  <= conv_std_logic_vector(200,TL);
	init_ram(clk,drvsig,monsig,statsig);
	printf("");

	printf("*****************************************************");
	printf("Test:  read_init");
	printf("no error added, turn off scrubing");
	printf("normal user read");
	printf("----------------------------------------------");
	statsig.testname  <= read_init; 
        drvsig.stop_scrub <= '1';
	usr_read_all(clk,drvsig,monsig,statsig,cflag);
	printf("");

	printf("*****************************************************");
	printf("Test: scrub_init");
	printf("turn on scrubing");
	printf("refreshing, and no user access");
	printf("no error to be corrected");
	printf("----------------------------------------------");
	-- this also put scrubing into know state, will report error next scrubing cycle.
	statsig.testname  <= scrub_init; 
        drvsig.stop_scrub <= '0';
	wait until monsig.scrub_done'event and monsig.scrub_done = '1';
	--wait for 4*halfperiod;
	printf("");

	printf("*****************************************************");
	printf("Test: add_1_err_init");
	printf("turn off scrubing");
	printf("add one error to each location");
	printf("----------------------------------------------");
	statsig.testname  <= add_1_err_init; 
        drvsig.stop_scrub <= '1';
	add_one_error(clk,drvsig,monsig,statsig);
	printf("");

	printf("*****************************************************");
	printf("Test: read_1_err_init");
	printf("turn off scrubing");
	printf("read/check 1 error in each location");
	printf("----------------------------------------------");
	statsig.testname  <= read_1_err_init; 
        drvsig.stop_scrub <= '1';
	usr_read_all(clk,drvsig,monsig,statsig,cflag);
	printf("");

	printf("*****************************************************");
	printf("Test: scrub_1_err_init");
	printf("turn on scrubing");
	printf("refreshing and no user access");
	printf("at last check all ram locations");
	printf("----------------------------------------------");
	statsig.testname  <= scrub_1_err_init; 
        drvsig.stop_scrub <= '0';
	wait until monsig.scrub_done'event and monsig.scrub_done = '1';
	printf("");
	printf("*****************************************************");
	printf("Test: read_1_err_scrubed");
	printf("turn on scrubing");
	printf("refreshing and no user access");
	printf("at last check all ram locations");
	printf("----------------------------------------------");
	statsig.testname  <= read_1_err_scrubed; 
        drvsig.stop_scrub <= '0';
	usr_read_all(clk,drvsig,monsig,statsig,cflag);
	printf("");

	printf("*****************************************************");
	printf("Test: read_1_err_scrubed");
	printf("turn on scrubing");
	printf("refreshing and no user access");
	printf("at last check all ram locations");
	printf("----------------------------------------------");
	statsig.testname  <= read_1_err_scrubed; 
        drvsig.stop_scrub <= '0';
	usr_read_all(clk,drvsig,monsig,statsig,cflag);
	printf("");

	printf("*****************************************************");
	printf("Test: add_1_err_2");
	printf("turn off scrubing");
	printf("add one error to each location");
	printf("----------------------------------------------");
	statsig.testname  <= add_1_err_2; 
        drvsig.stop_scrub <= '1';
	add_one_error(clk,drvsig,monsig,statsig);
	printf("");

	printf("*****************************************************");
	printf("Test: usr_rw");
	printf("turn on scrubing");
	printf("refreshing and user access");
	printf("at last check all ram locations");
	printf("----------------------------------------------");
	statsig.testname  <= usr_rw; 
        drvsig.stop_scrub <= '0';
	usr_read_write(clk,drvsig,monsig,statsig,cflag);
	printf("");

	printf("*****************************************************");
	printf("Test: usr_random_rw_err");
	printf("turn on scrubing");
	printf("random user access + random errors");
	printf("----------------------------------------------");
	statsig.testname  <= usr_random_rw_err; 
        drvsig.stop_scrub <= '0';
	usr_random_rw_err(10000,2,3, clk,drvsig,monsig,statsig,cflag);
	printf("");

	printf("*****************************************************");
	printf("Test: usr_random_2_err");
	printf("turn on scrubing");
	printf("test 2 error detections");
	printf("random user access + random 2 errors");
	printf("----------------------------------------------");
	statsig.testname  <= usr_random_2_err; 
        drvsig.stop_scrub <= '0';
	usr_random_2_err(10,2,3, clk,drvsig,monsig,statsig,cflag);

	printf("*****************************************************");
	printf("----------------------------------------------");
	printf("Test: init 2 test different RAM depth");  
	printf("Initialization");  
	printf("RAM depth=1024"); 
	printf("----------------------------------------------");
	statsig.testname  <= init; 
	statsig.rds       <= "0011"; 
        drvsig.stop_scrub <= '1';
        drvsig.tmout  <= conv_std_logic_vector(200,TL);
	init_ram(clk,drvsig,monsig,statsig);
	printf("");
	wait for 1000 ns;
	printf("*****************************************************");
	printf("Test: add_1_err_init");
	printf("turn off scrubing");
	printf("add one error to each location");
	printf("----------------------------------------------");
	statsig.testname  <= add_1_err_init; 
        drvsig.stop_scrub <= '1';
	add_one_error(clk,drvsig,monsig,statsig);
	printf("");

	printf("*****************************************************");
	printf("Test: scrub_1_err_init");
	printf("turn on scrubing");
	printf("refreshing and no user access");
	printf("at last check all ram locations");
	printf("----------------------------------------------");
	statsig.testname  <= scrub_1_err_init; 
        drvsig.stop_scrub <= '0';
	wait until monsig.scrub_done'event and monsig.scrub_done = '1';
	printf("");

	printf("*****************************************************");
	printf("Test: read_1_err_scrubed");
	printf("turn on scrubing");
	printf("refreshing and no user access");
	printf("at last check all ram locations");
	printf("----------------------------------------------");
	statsig.testname  <= read_1_err_scrubed; 
        drvsig.stop_scrub <= '0';
	usr_read_all(clk,drvsig,monsig,statsig,cflag);
	printf("");

	printf("*****************************************************");
	printf("----------------------------------------------");
	printf("Test: init 3 test different timer settings");  
	printf("Initialization");  
	printf("RAM depth=256"); 
	printf("----------------------------------------------");
	statsig.testname  <= init; 
	statsig.rds       <= "0000"; 
        drvsig.stop_scrub <= '1';
        drvsig.tmout  <= conv_std_logic_vector(2000,TL);
	init_ram(clk,drvsig,monsig,statsig);
	printf("");
	wait for 1000 ns;
	printf("*****************************************************");
	printf("Test: add_1_err_init");
	printf("turn off scrubing");
	printf("add one error to each location");
	printf("----------------------------------------------");
	statsig.testname  <= add_1_err_init; 
        drvsig.stop_scrub <= '1';
	add_one_error(clk,drvsig,monsig,statsig);
	printf("");

	printf("*****************************************************");
	printf("Test: scrub_1_err_init");
	printf("turn on scrubing");
	printf("refreshing and no user access");
	printf("at last check all ram locations");
	printf("----------------------------------------------");
	statsig.testname  <= scrub_1_err_init; 
        drvsig.stop_scrub <= '0';
	wait until monsig.tmoutflg'event and monsig.tmoutflg = '1';
	printf("");

	printf("*****************************************************");
	printf("Test: read_1_err_scrubed");
	printf("turn on scrubing");
	printf("refreshing and no user access");
	printf("at last check all ram locations");
	printf("----------------------------------------------");
	statsig.testname  <= read_1_err_scrubed; 
        drvsig.stop_scrub <= '0';
	usr_read_all(clk,drvsig,monsig,statsig,cflag);
	printf("");
	wait until monsig.tmoutflg'event and monsig.tmoutflg = '1';
	if statsig.err = 0  then
		 printf("All TESTS ARE PASSED");
	else
		 printf("ONE OR MORE TESTS ARE FAILED");
	end if;

	statsig.testname  <= finished; 
	stopclk <= '1';
	wait;
end process;

-- monitor the correction of the scrubing logic, not the user read.
process
begin
--	wait until clk'event and clk = CLKP;
	wait until (monsig.scrub_corrected'event and monsig.scrub_corrected = '1' ) or (statsig.clear'event and statsig.clear = '1');
	if  monsig.scrub_corrected = '1' then	
		cflag(conv_integer(monsig.caddr)) <= 1;
	end if;
	if  statsig.clear = '1' then	
		cflag(conv_integer(statsig.clearaddr)) <= 0;
	end if;
end process;

		
end edactb_behav;
